/*
 * sequence_reader.cpp
 *
 *  Created on: 2009/06/19
 *      Author: shu
 */

#include <assert.h>
#include <ios>
#include "sequence_reader.h"
#include "fasta_sequence_reader.h"

SequenceReaderPtr CreateSequenceReader(const char* file_name, Format format) {
  try {
    if (format == FASTA) {
      return SequenceReaderPtr(new FastaSequenceReader(file_name));
    } else {
      // error:format
      assert(!"file format error");
    }
  } catch (std::ios_base::failure &e) {
    throw e;
  }
}
