/*
 * sequence_reader.h
 *
 *  Created on: 2009/06/19
 *      Author: shu
 */

#ifndef SEQUENCE_READER_H_
#define SEQUENCE_READER_H_

#ifdef __GNUC__
#include <tr1/memory>
#else
// for nvcc 
#define __aligned__ ignored
#include <boost/tr1/memory.hpp>
#undef __aligned__
#endif

#include <stdexcept>
class Sequence;
class SequenceReader;

typedef std::tr1::shared_ptr<Sequence> SequencePtr;
typedef std::tr1::shared_ptr<SequenceReader> SequenceReaderPtr;

enum Format {
  FASTA
};

class SequenceReader {
public:
  virtual SequencePtr Read() = 0;
  virtual ~SequenceReader() {
  }
  ;
};

SequenceReaderPtr CreateSequenceReader(const char* file_name, Format format);
#endif /* SEQUENCE_READER_H_ */
